#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <dos.h>
#include "svga24.h"
#include "timer.h"
#include "mys.h"
#include "bmp.h"


void savescreen(int sx, int sy, rgb24 *scr) {
  int x, y, s, v;
  rgb hlp;
  s = (*scr).sirka;
  v = (*scr).vyska;

  for(x = 0; x < s; x ++) {
	for(y = 0; y < v; y ++) {
	  gixsvga(x + sx, y + sy, &hlp);
	  (*scr).pixels[x + y*s] = hlp;
	}
  }

}

void printscreen(int sx, int sy, rgb24 *scr) {
  int x, y, s, v;
  s = (*scr).sirka;
  v = (*scr).vyska;
  for(x = 0; x < s; x ++) {
	for(y = 0; y < v; y ++) {
	  pixsvga(x + sx, y + sy, (*scr).pixels[x + y * s].r, (*scr).pixels[x + y * s].g, (*scr).pixels[x + y * s].b);
	}
  }
}


void main(void) {
  timer t1;
  float cas;
  unsigned char c = 0;
  unsigned int x = 0, y = 0, x0, y0, x1, y1, sirka, vyska, pg, pgh;
  mouse mys;

  modsvga(0x115);
  setscann(1240);
  mys.set_maxxy(1240, 850);
  mys.set_xy(0,0);
  t1 = tstart();
  bmpvmem(0, 0, "../wsmap.bmp");
  bmpvmem(0, 1000, "../wsmap.bmp");
  cas = tstop(t1);
  rgb24 cursor, savescr[2];
  bmpread("../cursor.bmp", &cursor);
  sirka = cursor.sirka;
  vyska = cursor.vyska;

  savescr[0].sirka = sirka + vyska;
  savescr[0].vyska = sirka + vyska;
  savescr[0].pixels = (rgb*)malloc(sizeof(rgb) * savescr[0].sirka * savescr[0].vyska);
  if (savescr[0].pixels == NULL) {
	modvga(0x3);
	printf("Malo pameti\n");
	exit (1);
  }
  savescr[1].sirka = sirka + vyska;
  savescr[1].vyska = sirka + vyska;
  savescr[1].pixels = (rgb*)malloc(sizeof(rgb) * savescr[1].sirka * savescr[1].vyska);
  if (savescr[1].pixels == NULL) {
	modvga(0x3);
	printf("Malo pameti\n");
	exit (1);
  }

  x0 = mys.get_x();
  y0 = mys.get_y();
  pg = 0;
  pgh = 0;
  int out;
  savescreen(x0, y0, &savescr[1]);

  while (!kbhit()) {
	out = 0;
	while (out==0) {
	  mys.aktual();
	  if (mys.move()||kbhit()) out = 1;
	}
	x1 = mys.get_x();
	y1 = mys.get_y();
	savescreen(x1, y1 + pg, &savescr[pgh]);
	for(x = 0; x < sirka; x ++) {
	  for(y = 0; y < vyska; y ++) {
		if ((cursor.pixels[x + y*sirka].r != 255)||
			(cursor.pixels[x + y*sirka].g != 255)||
			(cursor.pixels[x + y*sirka].b != 255)) {
//		  savescr.pixels[(x) + (y)*savescr.sirka] = cursor.pixels[x + y*sirka];
		  pixsvga(x + x1, y + y1 + pg,cursor.pixels[x + y*sirka].r, cursor.pixels[x + y*sirka].g, cursor.pixels[x + y*sirka].b);
		}
	  }
	}
	setvirtual(mys.get_x()*0.35, mys.get_y()*0.3 + pg);
	if (pg == 0) pgh = 1;
	if (pg == 1000) pgh = 0;
	pg = pgh * 1000;
	printscreen(x0, y0 + pg, &savescr[pgh]);
	x0 = mys.get_x();
	y0 = mys.get_y();
  }

  bmpfree(&cursor);
  free(savescr[0].pixels);
  free(savescr[1].pixels);
  modvga(0x3);
  printf("%f", cas);
}
