#include <stdio.h>
#include <conio.h>
#include <math.h>
#include <dos.h>
#include "svga24.h"
#include "mys.h"
#include "keyb.h"
#include "3d.h"

void recomp(int POC, bod A[], tip anim)
{
	int i = 0, j = 0;
	tip t = 0, s = 0, r;
	for (i = 0; i<POC; i++) {
	  A[i].x = t*500;
	  r = sqrt((s-2)*(s-2)+(t-2)*(t-2));
	  A[i].z = sin(r*5-anim)/r*40-500;
	  A[i].y = s*500;
	  t += 0.1;
	  j ++;
	  if (j==40) {
		j = 0;
		t = 0;
		s += 0.1;
	  }
	}
}

#define POC 1600
#define MAXX 320
#define MAXY 200
#define VMEMSEG 0xA0000000L

void main(void) {
unsigned char far *vmem = (unsigned char far *)VMEMSEG;

bod A[POC];
obod O[POC];  // pomocny bod

tip d = 500;
tip anim = 0;  //anim - hodnota animace
int i = 0, j = 0;  // pomocne promenne do ciklu
int gx, gy;

mouse mys;
keyb key;
fly kamera;

recomp(POC, A, anim);
modvga(0x13);
mys.set_off();
kamera.set(0, 0, -500, 0, 0);

const stredx = int(MAXX/2);
const stredy = int(MAXY/2);

startscan();
char c='/n';
while(c!='q') {

  for (i = 0; i < POC; i ++) {
	if (O[i].z > 0) {
	  gx = stredx + O[i].x;
	  gy = stredy - O[i].y;
	  if ( (gx < MAXX)&&(gy < MAXY)&&(gx > 0)&&(gy > 0) )
		vmem[gx + gy*320] = 0;
	}
  }
  prumet(A, O, kamera.B, kamera.up, kamera.vp, d, 0, POC);
  for (i = 0; i < POC; i ++) {
	if (O[i].z > 0) {
	  gx = stredx + O[i].x;
	  gy = stredy - O[i].y;
	  if ( (gx < MAXX)&&(gy < MAXY)&&(gx > 0)&&(gy > 0) )
		vmem[gx + gy*320] = 30-O[i].z*0.003;
	}
  }
  recomp(POC, A, anim);
  delay(15);
  anim += 0.1;
  mys.move();

  c = '/n';
  if (kbhit()) c = getch();
  if (c==0) c = getch();
  key.clear();
  kamera.rotate(-mys.get_relativex()*0.003);
  kamera.look(-mys.get_relativey()*0.003);

  if (keys[75].pressed) kamera.strafe(10);
  if (keys[77].pressed) kamera.strafe(-10);
  if (keys[72].pressed) kamera.step(10);
  if (keys[80].pressed) kamera.step(-10);
  if (keys[22].pressed) d = d + 10;
  if (keys[23].pressed) d = d - 10;
  kamera.aktual();
};
stopscan();
modvga(0x3);
}