#include <graphics.h>
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <math.h>
#include <dos.h>
#include "vga.h"
#include "mys.h"
#include "keyb.h"
#include "3d.h"
#include "prumet.h"

#define POC 500
#define VID 30000
/*
void recomp(int poc, hranol Q[], tip anim)
{
	int i = 0, j = 0;
	tip t = 0, s = 0, r;
	for (i = 0; i<poc; i++) {
	}
}
*/
void main(void) {

//const POC = 100;  // pocet bodu
//const VID = 160000;  // konstata viditelnosti

vektor u = {60,0,0}, v = {0,0,60};
bod B = {-500,0,0};
tip d = 1000;
hranol Q[POC];
usecka P;
obod P1, P2;  // pomocny bod

tip anim = 0, vz = 0;  //anim - hodnota animace, vz - promenna pro vypocet viditelnosti
short int visual = 0;  //visual - viditelna stranka
short int out = 1;  // kontroluje vystup z ciklu
int i = 0, j = 0;  // pomocne promenne do ciklu

tip alfa = 0, beta = 0;
tip fullx;

randomize();
for(i = 0; i < POC; i++)
{
  Q[i].umisteni.x = random(10000)-5000;
  Q[i].umisteni.y = random(10000)-5000;
  Q[i].umisteni.z = random(10000)-5000;
  Q[i].velikost.x = random(1000);
  Q[i].velikost.y = random(1000);
  Q[i].velikost.z = random(1000);
}

bod p[2];
obod op[2];

mouse mys;
keyb key;

initvga(1);
gray();
mys.set_off();


const stredx = int(getmaxx()/2);
const stredy = int(getmaxy()/2);

fullx = fullx + mys.get_x() - stredx;
alfa = -fullx*0.005;
beta = -(mys.get_y()-stredy)*0.008;
u.x = cos(alfa)*10;
u.y = sin(alfa)*10;
u.z = sin(beta)*10;

setcolor(15);

char c='/n';
while(c!='q') {

  swapapage(visual);
  cleardevice();
  for (i = 0; i < POC; i++) {
	for (j = 1; j <= 12; j++) {
	  P = gethrana(j,Q[i]);
	  p[0] = P.A1;
	  p[1] = P.A2;
	  prumet(p,op,B,u,v,d,0,2);
	  P1 = op[0];
	  P2 = op[1];

	  if (P1.z>10) {
		vz = VID/(P1.z);
		if (vz<=15) {
		  setcolor(vz);
		}
		else setcolor(15);
		line(P1.x+stredx, P1.y+stredy, P2.x+stredx, P2.y+stredy);
	  }
	}
  }
  visual = swapvpage(visual);

  out = 1;
  mys.aktual();
  while (!kbhit() & (out)) {
	mys.aktual();
	if (mys.move()) out = 0;
  }

  c = '/n';
  if (kbhit()) c = getch();
  if (c==0) c = getch();
  key.clear();
  fullx = fullx + mys.get_x() - stredx;
  alfa = -fullx*0.005;
  beta = -(mys.get_y()-stredy)*0.008;
  mys.set_xy(stredx, mys.get_y());
  if (c==72) {
	B.x += cos(alfa)*10;
	B.y += sin(alfa)*10;
  }
  if (c==80) {
	B.x -= cos(alfa)*10;
	B.y -= sin(alfa)*10;
  }
  if (c==75) {
	B.x += cos(alfa+M_PI/2)*10;
	B.y += sin(alfa+M_PI/2)*10;
  }
  if (c==77) {
	B.x -= cos(alfa+M_PI/2)*10;
	B.y -= sin(alfa+M_PI/2)*10;
  }

  u.x = cos(alfa)*10;
  u.y = sin(alfa)*10;
  u.z = sin(beta)*10;
  if (c=='u') d = d + 10;
  if (c=='o') d = d - 10;
};
closegraph();
closegraph();
closegraph();
closegraph();
}