#include <graphics.h>
#include <stdio.h>
#include <conio.h>
#include <math.h>
#include <dos.h>
#include "vga.h"
#include "mys.h"
#include "keyb.h"
#include "prumet.h"

void recomp(int POC, bod A[], tip anim)
{
	int i = 0, j = 0;
	tip t = 0, s = 0, r;
	for (i = 0; i<POC; i++) {
/*
	  A[i].x = cos(t)*sqrt(100*100-(100-t)*(100-t));
	  A[i].y = sin(t)*sqrt(100*100-(100-t)*(100-t));
	  A[i].z = t-100;
	  t = t + 0.05;

	  A[i].x = cos(t)*100;
	  A[i].z = sin(t)*100;
	  A[i].y = t*10-50;
	  t = t + 0.02;
*/
	  A[i].x = t*500;
	  r = sqrt((s-2)*(s-2)+(t-2)*(t-2));
	  A[i].z = sin(r*5-anim)/r*40-500;
	  A[i].y = s*500;
	  t += 0.1;
	  j ++;
	  if (j==40) {
		j = 0;
		t = 0;
		s += 0.1;
	  }
	}
}

void main(void) {

const POC = 1600;  // pocet bodu
const VID = 16000;  // konstata viditelnosti

vektor u = {60,0,0}, v = {0,0,60};
bod B = {-500,0,0};
tip d = 1000;
bod A[2000];
bod P;  // pomocny bod

tip anim = 0, vz = 0;  //anim - hodnota animace, vz - promenna pro vypocet viditelnosti
short int visual = 0;  //visual - viditelna stranka
short int out = 1;  // kontroluje vystup z ciklu
int i = 0, j = 0;  // pomocne promenne do ciklu

tip alfa = 0, beta = 0;
tip fullx;

mouse mys;
keyb key;

recomp(POC, A, anim);
initvga(1);
gray();
mys.set_off();


const stredx = int(getmaxx()/2);
const stredy = int(getmaxy()/2);

fullx = fullx + mys.get_x() - stredx;
alfa = -fullx*0.005;
beta = -(mys.get_y()-stredy)*0.008;
u.x = cos(alfa)*10;
u.y = sin(alfa)*10;
u.z = sin(beta)*10;

setcolor(15);

char c='/n';
while(c!='q') {

  swapapage(visual);
  cleardevice();
  for (i=0; i<POC; i++) {
	P = prumet(u,v,A[i],B,d);
	if (P.z>10) {
	  vz = VID/P.z;
	  if (vz<=15) pix(P.x+stredx, P.y+stredy, vz);
	  else pix(P.x+stredx, P.y+stredy, 15);
	}
  }
  visual = swapvpage(visual);
  out = 1;
  mys.aktual();
  recomp(POC, A, anim);
  anim += 0.1;
  j = 0;
  while (!kbhit() & (out)) {
	mys.aktual();
	j ++;
	if (j>100) out = 0;
	if (mys.move()) out = 0;
  }

  c = '/n';
  if (kbhit()) c = getch();
  if (c==0) c = getch();
  key.clear();
  fullx = fullx + mys.get_x() - stredx;
  alfa = -fullx*0.005;
  beta = -(mys.get_y()-stredy)*0.008;
  mys.set_xy(stredx, mys.get_y());
  if (c==72) {
	B.x += cos(alfa)*10;
	B.y += sin(alfa)*10;
  }
  if (c==80) {
	B.x -= cos(alfa)*10;
	B.y -= sin(alfa)*10;
  }
  if (c==75) {
	B.x += cos(alfa+M_PI/2)*10;
	B.y += sin(alfa+M_PI/2)*10;
  }
  if (c==77) {
	B.x -= cos(alfa+M_PI/2)*10;
	B.y -= sin(alfa+M_PI/2)*10;
  }

  u.x = cos(alfa)*10;
  u.y = sin(alfa)*10;
  u.z = sin(beta)*10;
  if (c=='u') d = d + 10;
  if (c=='o') d = d - 10;
};
closegraph();
closegraph();
closegraph();
closegraph();
}