#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <math.h>
#include <dos.h>
#include "svga24.h"
#include "timer.h"
#include "keyb.h"
#include "bmp.h"

void otoc(rgb24 *obr, float u, float ax, float ay) {
  struct vektor {
	float x, y;
  };
  float x, y, z;
  float vx, vy, px, py, kx, ky;
  int i, pp;
  vektor sx, sy;
  z = 0.7;

  sx.x = cos(u)*10;
  sx.y = sin(u)*10;
  sy.x = -sx.y;
  sy.y = sx.x;
  vx = sqrt(sx.x*sx.x + sx.y*sx.y);
  vy = sqrt(sy.x*sy.x + sy.y*sy.y);
  sy.x = sy.x/vy*z;
  sy.y = sy.y/vy*z;
  sx.x = sx.x/vx*z;
  sx.y = sx.y/vx*z;
  px = (*obr).sirka/2;
  py = (*obr).vyska/2;
  for (kx = 0; kx < (*obr).sirka; kx ++) {
	for (ky = 0; ky < (*obr).vyska; ky ++) {
	  pp = kx + ky*(*obr).sirka;
	  if (((*obr).pixels[pp].r != 255)||
		  ((*obr).pixels[pp].g != 255)||
		  ((*obr).pixels[pp].b != 255)) {
		x = kx - px;
		y = (*obr).vyska - ky - py;
		pixsvga(sx.x * x + sy.x * y + ax, sx.y * x + sy.y * y + ay, (*obr).pixels[pp].r, (*obr).pixels[pp].g, (*obr).pixels[pp].b);
	  }
	}
  }
}


void savescreen(int sx, int sy, rgb24 *scr) {
  int x, y, s, v;
  rgb hlp;
  s = (*scr).sirka;
  v = (*scr).vyska;

  for(x = 0; x < s; x ++) {
	for(y = 0; y < v; y ++) {
	  gixsvga(x + sx, y + sy, &hlp);
	  (*scr).pixels[x + y*s] = hlp;
	}
  }

}

void printscreen(int sx, int sy, rgb24 *scr) {
  int x, y, s, v;
  s = (*scr).sirka;
  v = (*scr).vyska;
  for(x = 0; x < s; x ++) {
	for(y = 0; y < v; y ++) {
	  pixsvga(x + sx, y + sy, (*scr).pixels[x + y * s].r, (*scr).pixels[x + y * s].g, (*scr).pixels[x + y * s].b);
	}
  }
}

#define PAGE 2000
#define MAXX 1400
#define MAXY 1400
#define MAXX2 400
#define MAXY2 300

void main(void) {
  timer t1;
  float cas, u, v;
  unsigned char c = 0;
  unsigned int x = 0, y = 0, sirka, vyska, pg, pgh, ax, ay;
  float x0, y0, x1, y1;

  modsvga(0x115);
  setscann(MAXX);
  t1 = tstart();
  bmpvmem(0, 0, "../mapa01.bmp");
  bmpvmem(0, 1400, "../mapa01.bmp");
  bmpvmem(0, 1400 + PAGE, "../mapa01.bmp");
  bmpvmem(0, PAGE, "../mapa01.bmp");
  cas = tstop(t1);
  rgb24 cursor, savescr;
  bmpread("../auto03.bmp", &cursor);
  sirka = cursor.sirka;
  vyska = cursor.vyska;

  savescr.sirka = (sirka+vyska)*0.7;
  savescr.vyska = (sirka+vyska)*0.7;
  savescr.pixels = (rgb*)malloc(sizeof(rgb) * savescr.sirka * savescr.vyska);
  if (savescr.pixels == NULL) {
	modvga(0x3);
	printf("Malo pameti\n");
	exit (1);
  }
  ax = savescr.sirka / 2;
  ay = savescr.vyska / 2;
  x1 = MAXX2;
  y1 = MAXY2;
  x0 = x1;
  y0 = y1;
  pg = 0;
  pgh = 0;
  u = 0;
  v = 0;
  startscan();
  int out;

  while (c != 27) {
	if (keys[75].pressed) u -= v*0.02;
	if (keys[77].pressed) u += v*0.02;
	if (keys[72].pressed) v += 0.1;
	if (keys[80].pressed) v -= 0.1;
	if (keys[57].pressed) v = v*0.7;
	if (kbhit()) c = getch();
	x1 -= cos(u)*v;
	y1 -= sin(u)*v;
	if (x1 < sirka) x1 = sirka;
	if (y1 < vyska) y1 = vyska;
	if (x1 > MAXX - sirka) x1 = MAXX - sirka;
	if (y1 > MAXY - vyska) y1 = MAXY - vyska;
	savescreen(x0 - ax, y0 - ay + pg, &savescr);
	otoc(&cursor, u, x1, y1 + pg);
	if ((x1 - MAXX2 >= 0)&&
		(y1 - MAXY2 >= 0)) {
	  setvirtual(x1 - MAXX2, y1 - MAXY2 + pg);
	}
	if ((x1 - MAXX2 < 0)&&
		(y1 - MAXY2 < 0)) {
	  setvirtual(0, 0 + pg);
	}
	if ((x1 - MAXX2 < 0)&&
		(y1 - MAXY2 >= 0)) {
	  setvirtual(0, y1 - MAXY2 + pg);
	}
	if ((y1 - MAXY2 < 0)&&
		(x1 - MAXX2 >= 0)) {
	  setvirtual(x1 - MAXX2, 0 + pg);
	}

	if (pg == 0) pgh = 1;
	if (pg == PAGE) pgh = 0;
	pg = pgh * PAGE;
	printscreen(x0 - ax, y0 - ay + pg, &savescr);
	x0 = x1;
	y0 = y1;
//	delay(10);
  }
  stopscan();

  bmpfree(&cursor);
  free(savescr.pixels);
  modvga(0x3);
  printf("%f", cas);
}
