#include <dos.h>
#include <graphics.h>

void initvga(char mod) {
 if (mod > 0) {
   int gd, gm;
   gd = 9;
   gm = mod;
   initgraph(&gd, &gm, "../bgi");
 }
 else {
  struct REGS reg;
  reg.h.ah = 0x00;
  reg.h.al = -mod;
  int86(0x10, &reg, &reg);
 }
}

unsigned char getactivep(void) {
  struct REGS reg;
  unsigned char ap;
  reg.h.ah = 0x0f;
  int86(0x10, &reg, &reg);
  ap = reg.h.bh;
  return(ap);
}

void pix(int x, int y, unsigned char b) {
  putpixel(x, y, b);
}

void gray(void)
{
   struct palettetype pal;
   int i = 0;
   getpalette(&pal);
   for (i=0; i<pal.size; i++)
	  setrgbpalette(pal.colors[i], i*4, i*4, i*4);
}

int swapvpage(int visual)
{
  int vis = 0;
  if (visual == 0) {
	setvisualpage(1);
	vis = 1;
  }
  if (visual == 1) {
	setvisualpage(0);
	vis = 0;
  }
  return(vis);
}

void swapapage(int visual)
{
  if (visual == 0) setactivepage(1);
  if (visual == 1) setactivepage(0);
}

int swapvisualp(void)
{
  unsigned char visual = getactivep();
  if (visual == 0) setvisualpage(1);
  if (visual == 1) setvisualpage(0);
}

void swapactivep(void)
{
  unsigned char visual = getactivep();
  if (visual == 0) setactivepage(1);
  if (visual == 1) setactivepage(0);
}