#include <stdio.h>
#include <conio.h>
#include <math.h>
#include <dos.h>
#include "svga24.h"
#include "mys.h"
#include "keyb.h"
#include "3d.h"

void recomp(int POC, bod A[], tip anim)
{
	int i = 0, j = 0;
	tip t = 0, s = 0, r;
	for (i = 0; i<POC; i++) {
	  A[i].x = t*500;
	  r = sqrt((s-2)*(s-2)+(t-2)*(t-2));
	  A[i].z = sin(r*5-anim)/r*40-500;
	  A[i].y = s*500;
	  t += 0.1;
	  j ++;
	  if (j==40) {
		j = 0;
		t = 0;
		s += 0.1;
	  }
	}
}

#define POC 1600
#define MAXX 800
#define MAXY 600

void main(void) {

bod A[POC];
obod O[2][POC];  // pomocny bod

tip d = 1000;
tip anim = 0;  //anim - hodnota animace
int i = 0;  // pomocne promenne do ciklu
int page = 0, pageh = 0;
int gx, gy, gz;

mouse mys;
keyb key;
trote kamera;

recomp(POC, A, anim);
modsvga(0x115);
mys.set_off();
mys.set_maxxy(800,600);
kamera.set(0, 0, 1000, 1000, -500, 1000);

const stredx = int(MAXX/2);
const stredy = int(MAXY/2);

startscan();
char c='/n';
while(c!='q') {

  for (i = 0; i < POC; i ++) {
	if (O[pageh][i].z > 0) {
	  gx = stredx + O[pageh][i].x;
	  gy = stredy - O[pageh][i].y;
	  if ( (gx < MAXX)&&(gy < MAXY)&&(gx > 0)&&(gy > 0) ) {
		pixsvga(gx, gy + page, 0, 0, 0);
	  }
	}
  }
  if (page == 0) pageh = 1;
  if (page == MAXY) pageh = 0;

  prumet(A, O[pageh], kamera.B, kamera.up, kamera.vp, d, 0, POC);
  for (i = 0; i < POC; i ++) {
	gz = O[pageh][i].z;
	if (gz > 0) {
	  gx = stredx + O[pageh][i].x;
	  gy = stredy - O[pageh][i].y;
	  if ( (gx < MAXX)&&(gy < MAXY)&&(gx > 0)&&(gy > 0) ) {
		pixsvga(gx, gy + page, 255-gz*0.05, 255-gz*0.05, 255);
	  }
	}
  }
  recomp(POC, A, anim);
  setvirtual(0, page);
  anim += 0.1;
  mys.move();

  c = '/n';
  if (kbhit()) c = getch();
  key.clear();
  kamera.rotate(-mys.get_relativex()*0.005);
  kamera.look(-mys.get_relativey()*0.005);

//  if (keys[75].pressed) kamera.strafe(10);
//  if (keys[77].pressed) kamera.strafe(-10);
  if (keys[72].pressed) kamera.step(10);
  if (keys[80].pressed) kamera.step(-10);
  if (keys[22].pressed) d = d + 10;
  if (keys[23].pressed) d = d - 10;
  kamera.aktual();
  if (page == 0) pageh = 1;
  if (page == MAXY) pageh = 0;
  page = pageh*MAXY;
  if (page == 0) pageh = 1;
  if (page == MAXY) pageh = 0;
};
stopscan();
modvga(0x3);
}